hdu--4027(线段树更新操作的变形)

Can you answer these queries?

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)
Total Submission(s): 11488    Accepted Submission(s): 2693


Problem Description
A lot of battleships of evil are arranged in a line before the battle. Our commander decides to use our secret weapon to eliminate the battleships. Each of the battleships can be marked a value of endurance. For every attack of our secret weapon, it could decrease the endurance of a consecutive part of battleships by make their endurance to the square root of it original value of endurance. During the series of attack of our secret weapon, the commander wants to evaluate the effect of the weapon, so he asks you for help.
You are asked to answer the queries that the sum of the endurance of a consecutive part of the battleship line.

Notice that the square root operation should be rounded down to integer.
 

Input
The input contains several test cases, terminated by EOF.
  For each test case, the first line contains a single integer N, denoting there are N battleships of evil in a line. (1 <= N <= 100000)
  The second line contains N integers Ei, indicating the endurance value of each battleship from the beginning of the line to the end. You can assume that the sum of all endurance value is less than 2 63.
  The next line contains an integer M, denoting the number of actions and queries. (1 <= M <= 100000)
  For the following M lines, each line contains three integers T, X and Y. The T=0 denoting the action of the secret weapon, which will decrease the endurance value of the battleships between the X-th and Y-th battleship, inclusive. The T=1 denoting the query of the commander which ask for the sum of the endurance value of the battleship between X-th and Y-th, inclusive.
 

Output
For each test case, print the case number at the first line. Then print one line for each query. And remember follow a blank line after each test case.
 

Sample Input
  
  
10 1 2 3 4 5 6 7 8 9 10 5 0 1 10 1 1 10 1 1 5 0 5 8 1 4 8
 

Sample Output
  
  
Case #1: 19 7 6
 

Source
 
解题思路:模板的线段树更新操作中,都是某一整块区间都加上某个数,和减去某个数,而这题不能够整体更改,需要一个点一个点改,但这样容易超时,哪么接着我们可以发现,数最大为2^63,对于一个数经过6次更新便成为1,再更新大小就不会变了,始终为1,所以当一个区间其sum值等于区间长度时,就不用往下面更新了。
代码如下:
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<cmath>
using namespace std;
const int maxn=100000+1000;
int n,m;
__int64 a[maxn],sumv[maxn*6];
int op,ql,qr;
__int64 tmp;

void build(int o,int L,int R)
{
    int M=(L+R)/2;
    if(L==R)
    {
        sumv[o]=a[L];
    }
    else
    {
        build(o*2,L,M);
        build(o*2+1,M+1,R);
        sumv[o]=sumv[o*2]+sumv[o*2+1];
    }
}

void update(int o,int L,int R)
{


    int M=(L+R)/2;
    if(sumv[o]==R-L+1) return;//不需要更新了
    if(L==R)
    {
        sumv[o]=(__int64)sqrt(sumv[o]);
    }
    else
    {
        if(ql<=M)   update(o*2,L,M);
        if(qr>M)     update(o*2+1,M+1,R);
        sumv[o]=sumv[o*2]+sumv[o*2+1];
    }
}

__int64 query(int o,int L,int R)
{
    int M=(L+R)/2;
    if(ql<=L&&R<=qr)     return sumv[o];
    else
    {
        __int64 tmp=0;
        if(ql<=M)    tmp+=query(o*2,L,M);
        if(qr>M)      tmp+=query(o*2+1,M+1,R);
        return tmp;
    }
}

int main()
{
   int kase=0;
    int n,m;
    while(scanf("%d",&n)!=EOF)
    {
        for(int i=1; i<=n; i++)
            scanf("%I64d",&a[i]);
        build(1,1,n);
        scanf("%d",&m);
        printf("Case #%d:\n",++kase);
        for(int i=1;i<=m;i++)
        {
            scanf("%d%d%d",&op,&ql,&qr);
        if(ql>qr)  swap(ql,qr);
            if(op==0)
            {
                update(1,1,n);
            }
            else if(op=1)
            {
        printf("%I64d\n",query(1,1,n));
            }
        }
         printf("\n");
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值